import { Db } from 'mongodb';
import { Where, PaginatedResponse, ListFindQuery, DataSource, Mutation } from '@gqlify/server';
export declare class MongodbDataSource implements DataSource {
    private db;
    private collectionName;
    private objectCollection;
    private objectKey;
    private relationPath;
    constructor(db: Db, collectionName: string, key?: string);
    find(args?: ListFindQuery): Promise<PaginatedResponse>;
    findOne({ where }: {
        where: Where;
    }): Promise<any>;
    findOneById(id: string): Promise<any>;
    create(mutation: Mutation): Promise<any>;
    update(where: Where, mutation: Mutation): Promise<any>;
    delete(where: Where): Promise<any>;
    findOneByRelation(foreignKey: string, foreignId: string): Promise<any>;
    updateOneRelation(id: string, foreignKey: string, foreignId: string): Promise<any>;
    findManyFromOneRelation(foreignKey: string, foreignId: string): Promise<any[]>;
    findManyFromManyRelation(sourceSideName: string, targetSideName: string, sourceSideId: string): Promise<[{}, {}, {}, {}, {}, {}, {}, {}, {}, {}]>;
    addIdToManyRelation(sourceSideName: string, targetSideName: string, sourceSideId: string, targetSideId: string): Promise<void>;
    removeIdFromManyRelation(sourceSideName: string, targetSideName: string, sourceSideId: string, targetSideId: string): Promise<void>;
    getMap(): Promise<Record<string, any>>;
    updateMap(mutation: Mutation): Promise<any>;
    private whereToFilterQuery;
    private transformMutation;
}
