"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var lodash_1 = require("lodash");
var server_1 = require("@gqlify/server");
var defaultObjectCollection = 'canner-object';
var MongodbDataSource = (function () {
    function MongodbDataSource(db, collectionName, key) {
        this.relationPath = '__relation';
        this.transformMutation = function (mutation) {
            var payload = mutation.getData();
            mutation.getArrayOperations().forEach(function (operation) {
                var fieldName = operation.fieldName, operator = operation.operator, value = operation.value;
                if (operator !== server_1.ArrayOperator.set) {
                    return;
                }
                payload[fieldName] = value;
            });
            return payload;
        };
        this.db = db;
        this.collectionName = collectionName;
        var splits = this.collectionName.split('/');
        if (splits.length === 1) {
            this.objectCollection = defaultObjectCollection;
            this.objectKey = collectionName;
        }
        else if (splits.length >= 2) {
            this.objectCollection = splits[0];
            this.objectKey = splits[1];
        }
    }
    MongodbDataSource.prototype.find = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, pagination, where, _c, orderBy, filterQuery, query, filteredData;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _b = args || {}, pagination = _b.pagination, where = _b.where, _c = _b.orderBy, orderBy = _c === void 0 ? {} : _c;
                        filterQuery = this.whereToFilterQuery(where);
                        query = this.db.collection(this.collectionName).find(filterQuery);
                        query = lodash_1.isEmpty(orderBy) ? query : query.sort((_a = {}, _a[orderBy.field] = orderBy.value, _a));
                        return [4, query.project({ _id: 0 }).toArray()];
                    case 1:
                        filteredData = _d.sent();
                        return [2, server_1.paginate(filteredData, pagination)];
                }
            });
        });
    };
    MongodbDataSource.prototype.findOne = function (_a) {
        var where = _a.where;
        return __awaiter(this, void 0, void 0, function () {
            var filterQuery, filteredData;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        filterQuery = this.whereToFilterQuery(where);
                        return [4, this.db.collection(this.collectionName)
                                .find(filterQuery)
                                .project({ _id: 0 })
                                .toArray()];
                    case 1:
                        filteredData = _b.sent();
                        return [2, lodash_1.first(filteredData)];
                }
            });
        });
    };
    MongodbDataSource.prototype.findOneById = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var filteredData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.db.collection(this.collectionName)
                            .find({ id: id })
                            .project({ _id: 0 })
                            .toArray()];
                    case 1:
                        filteredData = _a.sent();
                        return [2, lodash_1.first(filteredData)];
                }
            });
        });
    };
    MongodbDataSource.prototype.create = function (mutation) {
        return __awaiter(this, void 0, void 0, function () {
            var payload, insertedItem, updatedItem;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        payload = this.transformMutation(mutation);
                        return [4, this.db.collection(this.collectionName).insertOne(payload)];
                    case 1:
                        insertedItem = _a.sent();
                        if (!insertedItem) return [3, 3];
                        return [4, this.db.collection(this.collectionName).findOneAndUpdate({ _id: insertedItem.insertedId }, {
                                $set: {
                                    id: insertedItem.insertedId.toString()
                                }
                            }, {
                                projection: { _id: 0 },
                                returnOriginal: false
                            })];
                    case 2:
                        updatedItem = _a.sent();
                        return [2, updatedItem.value];
                    case 3: return [2];
                }
            });
        });
    };
    MongodbDataSource.prototype.update = function (where, mutation) {
        return __awaiter(this, void 0, void 0, function () {
            var payload, filterQuery;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        payload = this.transformMutation(mutation);
                        filterQuery = this.whereToFilterQuery(where);
                        if (!!lodash_1.isEmpty(payload)) return [3, 2];
                        return [4, this.db.collection(this.collectionName).updateOne(filterQuery, { $set: payload })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2];
                }
            });
        });
    };
    MongodbDataSource.prototype["delete"] = function (where) {
        return __awaiter(this, void 0, void 0, function () {
            var filterQuery;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        filterQuery = this.whereToFilterQuery(where);
                        return [4, this.db.collection(this.collectionName).deleteOne(filterQuery)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    MongodbDataSource.prototype.findOneByRelation = function (foreignKey, foreignId) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, data;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4, this.db.collection(this.collectionName)
                            .find({})
                            .project({ _id: 0 })
                            .toArray()];
                    case 1:
                        data = _c.sent();
                        return [2, lodash_1.first(server_1.filter(data, (_a = {}, _a[foreignKey] = (_b = {}, _b[server_1.Operator.eq] = foreignId, _b), _a)))];
                }
            });
        });
    };
    MongodbDataSource.prototype.updateOneRelation = function (id, foreignKey, foreignId) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4, this.db.collection(this.collectionName).findOneAndUpdate((_a = {}, _a[foreignKey] = foreignId, _a), { $unset: (_b = {}, _b[foreignKey] = '', _b) })];
                    case 1:
                        _d.sent();
                        return [4, this.db.collection(this.collectionName).findOneAndUpdate({ id: id }, { $set: (_c = {}, _c[foreignKey] = foreignId, _c) }, { returnOriginal: false })];
                    case 2:
                        _d.sent();
                        return [2];
                }
            });
        });
    };
    MongodbDataSource.prototype.findManyFromOneRelation = function (foreignKey, foreignId) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, data;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4, this.db.collection(this.collectionName)
                            .find({})
                            .project({ _id: 0 })
                            .toArray()];
                    case 1:
                        data = _c.sent();
                        return [2, server_1.filter(data, (_a = {}, _a[foreignKey] = (_b = {}, _b[server_1.Operator.eq] = foreignId, _b), _a))];
                }
            });
        });
    };
    MongodbDataSource.prototype.findManyFromManyRelation = function (sourceSideName, targetSideName, sourceSideId) {
        return __awaiter(this, void 0, void 0, function () {
            var relationTableName, relationData, relationIds;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        relationTableName = "_" + sourceSideName + "_" + targetSideName;
                        return [4, this.db.collection(relationTableName).findOne({ sourceSideId: sourceSideId })];
                    case 1:
                        relationData = _a.sent();
                        relationIds = (relationData && relationData.targetSideIds)
                            ? relationData.targetSideIds
                            : [];
                        return [2, Promise.all(relationIds.map(function (id) { return _this.findOneById(id); }))];
                }
            });
        });
    };
    MongodbDataSource.prototype.addIdToManyRelation = function (sourceSideName, targetSideName, sourceSideId, targetSideId) {
        return __awaiter(this, void 0, void 0, function () {
            var relationTableName;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        relationTableName = "_" + sourceSideName + "_" + targetSideName;
                        return [4, this.db.collection(relationTableName).updateOne({ sourceSideId: sourceSideId }, {
                                $set: {
                                    sourceSideId: sourceSideId
                                },
                                $push: {
                                    targetSideIds: targetSideId
                                }
                            }, { upsert: true })];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    MongodbDataSource.prototype.removeIdFromManyRelation = function (sourceSideName, targetSideName, sourceSideId, targetSideId) {
        return __awaiter(this, void 0, void 0, function () {
            var relationTableName;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        relationTableName = "_" + sourceSideName + "_" + targetSideName;
                        return [4, this.db.collection(relationTableName).updateOne({ sourceSideId: sourceSideId }, {
                                $pull: {
                                    targetSideIds: targetSideId
                                }
                            })];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    MongodbDataSource.prototype.getMap = function () {
        return __awaiter(this, void 0, void 0, function () {
            var filteredData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.db.collection(this.objectCollection)
                            .findOne({ key: this.objectKey })];
                    case 1:
                        filteredData = _a.sent();
                        return [2, filteredData];
                }
            });
        });
    };
    MongodbDataSource.prototype.updateMap = function (mutation) {
        return __awaiter(this, void 0, void 0, function () {
            var payload;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        payload = this.transformMutation(mutation);
                        if (!!lodash_1.isEmpty(payload)) return [3, 2];
                        return [4, this.db.collection(this.objectCollection)
                                .updateOne({ key: this.objectKey }, { $set: payload }, { upsert: true })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2];
                }
            });
        });
    };
    MongodbDataSource.prototype.whereToFilterQuery = function (where) {
        var filterQuery = {};
        server_1.iterateWhere(where, function (field, op, value) {
            switch (op) {
                case server_1.Operator.eq:
                    filterQuery[field] = value;
                    break;
                case server_1.Operator.gt:
                    filterQuery[field] = { $gt: value };
                    break;
                case server_1.Operator.gte:
                    filterQuery[field] = { $gte: value };
                    break;
                case server_1.Operator.lt:
                    filterQuery[field] = { $lt: value };
                    break;
                case server_1.Operator.lte:
                    filterQuery[field] = { $lte: value };
                    break;
            }
        });
        return filterQuery;
    };
    return MongodbDataSource;
}());
exports.MongodbDataSource = MongodbDataSource;
//# sourceMappingURL=mongodbDataSource.js.map